<?php
// standard theme module type-B
// by team1/3

	global $params,$html,$ut,$database;
	$params['pagination_renderer'] = "my_pagination_renderer";
	$params['page']['meta']['hide-title'] = true;

// ツールバーのカスタマイズ
function custom_toolbar()
{
	global $html,$ut;
	if (check_rights('edit')) {
		if (!check_rights('admin')) {
			unset($html['system_toolbar']['MENU']['10']);
			unset($html['system_toolbar']['MENU']['11']);
		} else {
			$html['system_toolbar']['MENU'][1][] = "<a href='{$ut->link('manager')}' >Theme Manager</a>";
		}
		ksort($html['system_toolbar']['MENU']);
	} else {
		unset($html['system_toolbar']['MENU']);
	}
}

function get_catch_html($embed=false)
{
	global $params,$ut;

	$meta = get_theme_metadata();
$out = <<<EOT
	<h1>{$params['circle']['name']}</h1>
	<p>This is a simple hero unit, a simple jumbotron-style component for calling extra attention to featured content or information.</p>
	<p><a class="btn btn-primary btn-lg">Learn more</a></p>
EOT;
	if (!empty($meta['plugin_embed']['catch_text'])) {
		$out = $meta['plugin_embed']['catch_text'];
	}
	if ($embed) {
		if (!empty($meta['plugin_embed']['catch_text'])) {
			$params["_embed_cache"][$ut->get_home_id()]['plugin_embed']['catch_text'] = $meta['plugin_embed']['catch_text'];
		} else {
			$params["_embed_cache"][$ut->get_home_id()]['plugin_embed']['catch_text'] = $out;
		}
	}
	return $out;
}

function jumbotron()
{
	global $html,$params,$database,$ut,$config;
	$meta = get_theme_metadata();
	
	if (isset($meta['flexfile']['main_visual'] )) {
		$img = str_replace("&amp;","&",$meta['flexfile']['main_visual']);
		$c = '#000';
		if (!empty($meta['flexcolor']['main_font_color'])) {
			$c = $meta['flexcolor']['main_font_color'];
		}
$html['css'][] = <<<EOT
		<style>
			.jumbotron {
				background-image:url({$img});
				background-size:100%;
				color:$c;
			}
			@media screen and (max-width: 600px) {
				.jumbotron {
					background-size:120%;
					max-height:220px;
					overflow: hidden;
				}
			}
		</style>
EOT;
	}

	return get_catch_html();
}

//各ページからのログインが有効でかつ非ログイン状態の場合は、ログインプログラムをロード
if (!check_rights() && empty($params['circle']['meta']['hide_login'])) {
	snippet_loginform(1);
}

// グローバルナビ(テーマに合わせてカスタマイズ、get_gnavがtplで使われていなければ削除可能)
function get_gnav()
{
	global $html,$params,$database,$ut,$config;

	$link = "link_proc";

	$top_page = $params['circle']['meta']['top_page'];
	$meta = get_theme_metadata();
	
	$buff = '';
	if (isset($meta['theme']['global_menu'])) {
		foreach ($meta['theme']['global_menu'] as $v) {
			$u = ex_theme_link($v['link']);
			$n = $v['text'];
			$s = "";
			$u0 = trim($u,'/');
			if ($params['request'] == $u0) {
				$s = " active ";
			} else {
				foreach ($params['breadcrumb'] as $v) {
					if (trim($v['link'],'/') == $u0) {
						$s = " active ";
						break;
					}
				}
			}
			$buff .= "<li class='$s' ><a href='$u' >$n</a></li>";
		}
	} else {
$buff .= <<<EOT
		<li><a href="{$ut->link()}"  >HOME</a></li>
		<li><a href="{$ut->link('list')}"  >Page list</a></li>
EOT;
	}
	if (!check_rights() && empty($params['circle']['meta']['hide_login'])) {
$buff .= <<<EOT
		<li><a href='javascript:void(ot.show_login_panel())'  >Login</a></li>
EOT;
	}
	return $buff;
}

// for breadcrumb (テーマに合わせてカスタマイズ)
function breadcrumb()
{
	global $params,$ut;
	if ( isset($params['circle']) && isset($params['circle']['name']) ) {
		$name = $params['circle']['name'];
		if ( isset($params['breadcrumb']) ) {
			//パンくずの作成
			$a = '';
			if ( is_array($params['breadcrumb']) ) {
				$c = count($params['breadcrumb']);
				for ( $i=0; $i < $c; ++$i ) {
					$v = $params['breadcrumb'][$i];
					if ( $i != $c-1 ) {
						$d1 = '';
					} else {
						$d1 = ' class="active" ';
					}
					if ( $v['link'] ) {
$a .= <<<EOT
						<li $d1><a href="{$v['link']}">{$v['text']}</a> </li>
EOT;
					} else {
$a .= <<<EOT
						<li $d1>{$v['text']} </li>
EOT;
					}
				}
			}
			return '<ul class="breadcrumb " >'.$a.'</ul>';
		}
	}
	return '';
}

// 絶対パスのURLは、そのままそれ以外はパス調整する
function ex_theme_link($u)
{
	global $ut;
	if (preg_match("/(https?:)?\/\//",$u)) {
		return $u;
	}
	return $ut->link($u);
}

// for system toolbar (通常は変更不可)
function system_toolbar()
{
	global $html,$params,$config,$ut,$p_circle;
	
	if (!check_rights()) {
		return '';
	}

	custom_toolbar();

	//system_toolbarの整形
	$x = array();
	foreach ($html['system_toolbar'] as $k=>$v) {
		if (!is_array($v)) {
			$x['opt'][] = $v;
		} else {
			foreach ($v as $vv) {
				if (is_array($vv)) {
					if (!isset($vv['caption'])) {
						foreach ($vv as $vvv) {
							$x['opt'][] = $vvv;
						}
					} else {
						$x[$k][] = $vv;
					}
				} else {
					$x[$k][] = $vv;
				}
			}
		}
	}
	$html['system_toolbar'] = $x;

	$opacity = "0.5";
	// system nav css
$buff = <<<EOT
	<style>
	.ot-show {
	  opacity: 1 !important;
	}
	.onethird-system-nav-typeB {
	  position: fixed;
	  top: 0;
	  left: 0;
	  padding: 5px;
	  text-align: left;
	  font-size: 14px;
	  background-color: rgba(0, 0, 0, 0.8);
	  background-color: #222\9;
	  border: 2px solid #fff;
	  color: #e0e0e0;
	  z-index: 99999;
	  opacity: $opacity;
	  box-shadow: 0px 0px 6px #000000;
	  font-family: 'Lucida Console',Verdana, Roboto, 'Droid Sans', Meiryo, 'Hiragino Kaku Gothic ProN';
	  font-size:16px;
	}
	.onethird-system-nav-typeB:hover {
	  opacity: 1;
	}
	.onethird-system-nav-typeB a,
	.onethird-system-nav-typeB a:hover {
	  text-decoration: none;
	}
	.onethird-system-nav-typeB a,
	.onethird-system-nav-typeB a:link,
	.onethird-system-nav-typeB a:visited {
	  color: #e0e0e0;
	  text-decoration: none;
	}
	.onethird-system-nav-typeB a:hover {
	  color: #08C;
	}
	.onethird-system-nav-typeB img {
	  width: 25px;
	  margin: 2px;
	  -webkit-box-sizing: initial; // for bootstrap
	  -moz-box-sizing: initial;
	  box-sizing: initial;
	}
	.onethird-system-nav-typeB .inner {
	  width: 30px;
	  padding: 0;
	}
	.onethird-system-nav-typeB img {
	  vertical-align: middle;
	}
	.onethird-system-nav-typeB .dropdown_item {
	  float: left;
	  position: relative;
	  cursor: pointer;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box {
	  background-color: rgba(0, 0, 0, 0.9);
	  background-color: #222\9;
	  padding: 9px;
	  position: absolute;
	  top: 15px;
	  left: 30px;
	  width: 250px;
	  -webkit-border-radius: 3px;
	  -moz-border-radius: 3px;
	  border-radius: 3px;
	  -webkit-box-shadow: 0px 0px 6px #8d8b8b;
	  -moz-box-shadow: 0px 0px 6px #8d8b8b;
	  box-shadow: 0px 0px 6px #8d8b8b;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box div :hover {
	  color: #08C;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box .item {
	  padding: 2px;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box .item a {
	  border: none;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box .dropdown_box_sub {
		left: 7px;
		position: relative;
		margin-bottom: 13px;
		top: 4px;
	}
	.ot-hidden {
		opacity: 0;
		-webkit-transition: opacity linear 0.5s;
		-moz-transition: opacity linear 0.5s;
		-ms-transition: opacity linear 0.5s;
		-o-transition: opacity linear 0.5s;
		transition: opacity linear 0.5s;
	}
	.onethird-system-nav-typeB .dropdown_item .dropdown_box.ot-hidden:hover {
	  opacity: 1;
	}
	.onethird-system-nav-typeB .dropdown_item hr {
	  border: 0;
	  border-bottom: 1px dashed #858585;
	  background: #000;
	}
	.onethird-system-nav-typeB.ot-hidden:hover {
	  opacity: 1;
	}
	@media (max-width: 767px) {
	  .onethird-system-nav-typeB {
		font-size: 120%;
		line-height: 160%;
		top: initial;
		bottom: 0;
	  }
	  .onethird-system-nav-typeB img {
		width: 35px;
		height: 35px;
	  }
	  .onethird-system-nav-typeB.ot-hidden {
		opacity: 0.3;
	  }
	  .onethird-system-nav-typeB .inner {
		width: initial;
		padding: 0;
	  }
	  .onethird-system-nav-typeB .dropdown_item .dropdown_box {
		top: initial;
		bottom: 47px;
	  }
	  body {
	  	padding-bottom: 45px;
	  }
	}
	</style>
EOT;
	$html['css']['system_toolbar'] = $buff;

	$buff = '';
	if (!function_exists('sub_item')) {
		function sub_item($ar) {
$buff = <<<EOT
			<div style='position:relative;'>
				<div class='dropdown_hnd_sub '>
					<div class='sub_menu'>{$ar['caption']}</div>
					<div class="dropdown_box_sub dropdown_box" style='display:none;z-index:1000;'>
EOT;
						foreach ($ar as $k=>$v) {
							if (!is_numeric($k)) { continue; }
$buff .= <<<EOT
							<div class="item">
								$v
							</div> 
EOT;
						}
$buff .= <<<EOT
					</div> 
				</div> 
			</div> 
EOT;
			return $buff;
		}
	} else {
		if (check_rights()) {
			$html['alert'][] = 'system_toolbar-tag is duplicated.';
		}
	}
	$avatar = get_user_avatar_ex(array('alt'=>'Account setting','size'=>0));
$buff .= <<<EOT
<div class="onethird-system-nav-typeB" >
	<div class="inner">
		<div class="dropdown_item">
			<div style='padding:2px;display: inline-block;'>$avatar</div>
EOT;
			if ( isset($html['system_toolbar']) && $html['system_toolbar'] ) {
				foreach ($html['system_toolbar'] as $k=>$v) {
					if (!is_array($v) || count($v) == 0) {
						continue;
					}
					if ($k === 0) {
						$icon = $ut->icon('system');
					} else if ($k === 10) {
						$icon = $ut->icon('lock');
					} else if ($k == 'opt') {
						$icon = $ut->icon('folder',"width='32'");
					} else {
						$icon = $ut->icon('folder2',"width='32'");
					}
					$tmp = '';
					foreach ($v as $kk=>$vv) {
						if (!$vv) { continue; }
						if (is_array($vv)) {
							$tmp .= sub_item($vv);
							continue;
						}
$tmp .= <<<EOT
						<div class="item">
							$vv
						</div> 
EOT;
					}
					if ($tmp) {
$buff .= <<<EOT
						<span class='dropdown_hnd'>$icon</span>
						<div class="dropdown_box_root dropdown_box" style='display:none;'>
							$tmp
						</div> 
EOT;
					}
				}

$buff .= <<<EOT
EOT;
			}

$buff .= <<<EOT

		</div>
	</div>
</div>
EOT;

$buff .= <<<EOT
		<script>
		\$(function(){
			\$("body").bind("click", function (e) {
				\$('.dropdown_hnd').next().hide(100);
				\$(".onethird-system-nav-typeB").removeClass("ot-show");
				\$('.dropdown_hnd').next().removeClass('ot-show').hide(200);
			});
			\$(".dropdown_hnd").click(function (e) {
				var obj = \$(this);
				var top = (e.clientY-8)+'px';
				if (\$(window).scrollTop()+100 < \$('.onethird-system-nav-typeB').offset().top) {
					top = 'inherit';
				}
				var n = obj.next();
				if (n.hasClass('ot-show')) {
					n.removeClass('ot-show').hide(100);
				} else {
					\$('.dropdown_hnd').next().removeClass('ot-show').hide(100);
					n.css('top',top);
					n.addClass('ot-show').show(200);
				}
				\$(".onethird-system-nav-typeB").addClass("ot-show");
				if (\$('body').width() < 767) {
					\$('.edit_pointer').show();
				}
				return false;
			}); 
			\$(".onethird-system-nav-typeB .sub_menu").click(
				function (e) {
					var n = \$(this).next();
					if (n.hasClass("ot-show")) {
						n.removeClass('ot-show').hide(100);
						return false;
					} else {
						\$(".dropdown_box_sub ").hide();
						n.addClass('ot-show').show(200);
						return false;
					}
				}
			);
			
EOT;
			if ( isset($params['circle']['meta']['hide_nav']) ) {
$buff .= <<<EOT
				\$('.onethird-system-nav-typeB').addClass('ot-hidden');
EOT;
			} else {
$buff .= <<<EOT
				\$('.dropdown_box').addClass('ot-hidden');
				\$('.dropdown_box').hover(null,function(){
					\$('.dropdown_box').addClass('ot-hidden');
				});
EOT;
			}

$buff .= <<<EOT
		});
		</script>
EOT;

	snippet_overlay();

	if (isset($html['information'])) {
		$buff .= "<div class='onethird-information' onclick='\$(this).remove()' >";
		foreach ($html['information'] as $v) {
			$buff .= "<div>$v</div>";
		}
		$buff .= "</div>";
	}
	
	if (isset($html['alert'])) {
$buff .= <<<EOT
		<script>
			\$(function(){
EOT;
				foreach ($html['alert'] as $v) {
					$buff .= "ot.alert(\"$v\");";
				}
$buff .= <<<EOT
			});
		</script>
EOT;
	}

	return $buff;

}


function my_pagination_renderer( $option )
{
	global $config,$params;
	
	if (!isset($option['total'])) { return 'pagination-error'; }
	if (!isset($option['offset'])) { $option['offset'] = 0; }
	if (!isset($option['page_size'])) { $option['page_size'] = 100; }
	if (!isset($option['max_pagination'])) { $option['max_pagination'] = 10; }
	if (!isset($option['previous'])) { $option['previous'] = ''; }
	if (!isset($option['next'])) { $option['next'] = ''; }
	
	$buff = '';
	if ($option['total'] && $option['total'] > $option['page_size']) {
		$ar = array();
		pagination_urls( $ar, $option );

		$buff.='<div ><ul class="pagination">';
		if (isset($ar['prev'])) {
			$buff.="<li class='prev'><a href='{$ar['prev']}'>&larr; {$option['previous']}</a></li>";
		} else {
			$buff.="<li class='prev disabled'><a>&larr; {$option['previous']}</a></li>";
		}
		
		foreach($ar['mid'] as $k=>$v) {
			if ($v == '...') {
				$buff .= "<li style='background: none; color: inherit; border: none;padding-left:0;padding-right:0;'>...</li>";
				continue;
			}
			$buff.="<li ";
			if ( $option['offset'] == $k ) {
				$buff.=" class='active' ";
			}
			$buff.=" ><a href='{$v}'>".((int)$k+1)."</a></li>";
		}
		
		if (isset($ar['next'])) {
			$buff.="<li class='next'><a href='{$ar['next']}'>{$option['next']} &rarr;</a></li>";
		} else {
			$buff.="<li class='next disabled'><a>{$option['next']} &rarr;</a></li>";
		}
		$buff .= '</ul></div>';
	}

	return $buff;
}


?>